local donjons = {}

-- load the library "lib"
lib = require("lib")

-- ability modifier
-- returns the modifier computed from the value of an ability (6 => -2, 12 => +1, etc.)
function donjons.abilityMod(ability)
	n = (ability - 10)//2
	s = n < 0 and "" or "+" -- read (n < 0 and "") or ("+") (ternary)
	return s .. (ability - 10)//2
end


function donjons.wt(weapon, lvl, ab, dadd)
	hit = "1d20" 
	damage = "0"
	rang = ""
	if (weapon == "fireball") then
		hit = "1d20e19" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)
		damage = tostring(1+dadd) .. "d6" 
		rang = ""
	end
			-- sorts liés au moine
			if (weapon == "déluge de coup") then hit = ""
				damage = "0"	
				rang = "Ki 1 point"
				end
					if (level < 5) then damage = tostring("1d4") end
					if (11 > level) and (level >= 5)  then damage = tostring("1d6") end
					if (17 > level) and (level >= 11) then damage = tostring("1d8") end
					if (17 < level) then damage = tostring("1d10") end
					
				if (weapon == "parade de projectiles") then hit = "1d10" .. donjons.abilityMod(ab["dex"]) .. "+" .. level
				damage = "0"	
				rang = "Ki, réaction"
				end
				if (weapon == "âme de diamant") then hit = ""         damage = ""	     rang = "Ki 1 point nouveau JdS "   end
				if (weapon == "frappe étourdissante") then hit = ""         damage = ""	     rang = "Ki 1 point JdS Con"   end
				if (weapon == "fouet d´eau") then hit = ""         damage = "3d10"	     rang = "Ki niveau 3"   end
				if (weapon == "gong du sommet") then hit = "" damage = "3d8"      rang = "Ki 3 points (jds con) "  end
				if (weapon == "frappe incandescente") then hit = "" damage = "3d6"      rang = "Ki 2 points (jds dex) "  end
				if (weapon == "poigne de vent du nord") then hit = "" damage = "paralysie"      rang = "Ki 2 points (jds sag) "  end
				if (weapon == "poing de l´air") then hit = "" damage = "3d10"      rang = "Ki 2 points (jds For) "  end
				if (weapon == "poing des 4 tonnerres") then hit = "" damage = "2d8"      rang = "Ki 2 points (jds con) "  end
				if (weapon == "rivière de la flamme") then hit = "" damage = "5d8"      rang = "Ki 5 points, niv17 (jds dex)"  end
				if (weapon == "ruée des esprits du vent") then hit = "" damage = ""      rang = "Ki 2 points"  end
				if (weapon == "souffle de l´hiver") then hit = "" damage = "8d8"      rang = "Ki 6 points, niv17 (jds dex)"  end
				if (weapon == "vague de terre grondante") then hit = "" damage = ""      rang = "Ki 6 points, niv17 (jds dex)"  end
				if (weapon == "corps vide") then hit = "" damage = ""      rang = "Ki 4 points, niv18 (invisible)"  end
				if (weapon == "frappe du phénix") then hit = "" damage = "8d6"      rang = "Ki 4 points, niv11 (JdS dex)"  end
				if (weapon == "crochet du serpent de feu") then hit = "1d20" .. donjons.abilityMod(ab["dex"]) .. "+" .. level       damage = "1d10"      rang = "Ki 1 point, niv2"  end
				
				
				-- sorts liés au moine
			if (weapon == "flurry of blows") then hit = ""
				damage = "0"	
				rang = "Ki 1 point"
				end
					if (level < 5) then damage = tostring("1d4") end
					if (11 > level) and (level >= 5)  then damage = tostring("1d6") end
					if (17 > level) and (level >= 11) then damage = tostring("1d8") end
					if (17 < level) then damage = tostring("1d10") end
					
				if (weapon == "deflect missiles") then hit = "1d10" .. donjons.abilityMod(ab["dex"]) .. "+" .. level
				damage = "0"	
				rang = "Ki, réaction"
				end
				if (weapon == "diamond soul") then hit = ""         damage = ""	     rang = "Ki 1 point nouveau JdS "   end
				if (weapon == "stunning strike") then hit = ""         damage = ""	     rang = "Ki 1 point JdS Con"   end
				if (weapon == "water whip") then hit = ""         damage = "3d10"	     rang = "Ki niveau 3"   end
				if (weapon == "gong of the summit") then hit = "" damage = "3d8"      rang = "Ki 3 points (jds con) "  end
				if (weapon == "sweeping cinder strike") then hit = "" damage = "3d6"      rang = "Ki 2 points (jds dex) "  end
				if (weapon == "clench of the north") then hit = "" damage = "paralysie"      rang = "Ki 2 points (jds sag) "  end
				if (weapon == "fist of unbroken air") then hit = "" damage = "3d10"      rang = "Ki 2 points (jds For) "  end
				if (weapon == "fist of the four thunders") then hit = "" damage = "2d8"      rang = "Ki 2 points (jds con) "  end
				if (weapon == "river of hungry flame") then hit = "" damage = "5d8"      rang = "Ki 5 points, niv17 (jds dex)"  end
				if (weapon == "rush of the gale spirits") then hit = "" damage = ""      rang = "Ki 2 points"  end
				if (weapon == "breath of winter") then hit = "" damage = "8d8"      rang = "Ki 6 points, niv17 (jds dex)"  end
				if (weapon == "wave of rolling earth ") then hit = "" damage = ""      rang = "Ki 6 points, niv17 (jds dex)"  end
				if (weapon == "empty body") then hit = "" damage = ""      rang = "Ki 4 points, niv18 (invisible)"  end
				if (weapon == "flames of the phoenix") then hit = "" damage = "8d6"      rang = "Ki 4 points, niv11 (JdS dex)"  end
				if (weapon == "fangs of the fire snake") then hit = "1d20" .. donjons.abilityMod(ab["dex"]) .. "+" .. level       damage = "1d10"      rang = "Ki 1 point, niv2"  end
				
			-- competences du roublard
			if (weapon == "attaque sournoise") then hit = ""
				damage = "0"	
				rang = ""
				end
					if (level == 1) then damage = tostring("1d6") end
					if (level == 2) then damage = tostring("1d6") end
					if (level == 3) then damage = tostring("2d6") end
					if (level == 4) then damage = tostring("2d6") end
					if (level == 5) then damage = tostring("3d6") end
					if (level == 6) then damage = tostring("3d6") end
					if (level == 7) then damage = tostring("4d6") end
					if (level == 8) then damage = tostring("4d6") end
					if (level == 9) then damage = tostring("5d6") end
					if (level == 10) then damage = tostring("5d6") end
					if (level == 11) then damage = tostring("6d6") end
					if (level == 12) then damage = tostring("6d6") end
					if (level == 13) then damage = tostring("7d6") end
					if (level == 14) then damage = tostring("7d6") end
					if (level == 15) then damage = tostring("8d6") end
					if (level == 16) then damage = tostring("8d6") end
					if (level == 17) then damage = tostring("9d6") end
					if (level == 18) then damage = tostring("9d6") end
					if (level >= 19) then damage = tostring("10d6") end
				
						-- competences du roublard
			if (weapon == "sneak attack") then hit = ""
				damage = "0"	
				rang = ""
				end
					if (level == 1) then damage = tostring("1d6") end
					if (level == 2) then damage = tostring("1d6") end
					if (level == 3) then damage = tostring("2d6") end
					if (level == 4) then damage = tostring("2d6") end
					if (level == 5) then damage = tostring("3d6") end
					if (level == 6) then damage = tostring("3d6") end
					if (level == 7) then damage = tostring("4d6") end
					if (level == 8) then damage = tostring("4d6") end
					if (level == 9) then damage = tostring("5d6") end
					if (level == 10) then damage = tostring("5d6") end
					if (level == 11) then damage = tostring("6d6") end
					if (level == 12) then damage = tostring("6d6") end
					if (level == 13) then damage = tostring("7d6") end
					if (level == 14) then damage = tostring("7d6") end
					if (level == 15) then damage = tostring("8d6") end
					if (level == 16) then damage = tostring("8d6") end
					if (level == 17) then damage = tostring("9d6") end
					if (level == 18) then damage = tostring("9d6") end
					if (level >= 19) then damage = tostring("10d6") end	
				
				-- sorts 
				
				if (weapon == "protection contre les armes") then hit = "1d20"
				damage = "0"	
				rang = "tour"
				end
				
				if (weapon == "résistance") then hit = ""	
				damage = "0"
				rang = "tour"
				end
				if (weapon == "assistance") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				
				if (weapon == "coup au but") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "amis") then hit = ""	
				damage = "0"	
				rang = "tour"
				end
				if (weapon == "moquerie cruelle") then hit = ""	
				damage = tostring(1+dadd) .. "d4"	
				rang = "tour"
				end
				if (weapon == "coup de tonnerre") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"
				rang = "tour"
				end

				if (weapon == "décharge occulte") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d10"	
				rang = "tour"
				end
				if (weapon == "flamme sacrée") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"	
				rang = "tour"
				
				end
				if (weapon == "fouet foudroyant") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"	
				rang = "tour"
				
				end
				if (weapon == "gelure") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"
				rang = "tour"
				
				end
				if (weapon == "lame aux flammes vertes") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"
				rang = "tour"
				end
				
				if (weapon == "lame tonnante") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"
				rang = "tour"
				end
				if (weapon == "lumière") then hit = ""	
				damage = "0"
				rang = "tour"
				end
				if (weapon == "lumières dansantes") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "mot de radiance") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"	
				rang = "tour"
				end
				if (weapon == "poigne électrique") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"	
				rang = "tour"
				end
				if (weapon == "rayon de givre") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"
				rang = "tour"
				end
				if (weapon == "trait de feu") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d10"	
				rang = "tour"
				end
				if (weapon == "	illusion mineure") then hit = "" 		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "aspersion d'acide") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"
				rang = "tour"
				end
				if (weapon == "embrasement") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"	
				rang = "tour"
				end
				if (weapon == "explosion de lames") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"
				rang = "tour"
				end
				if (weapon == "infestation") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"
				rang = "tour"
				end
				if (weapon == "main de mage") then hit = ""		
				damage = "0" 
				rang = "tour"
				end
				if (weapon == "production de flamme") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"
				rang = "tour"
				end
				if (weapon == "vaporisation de poison") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d12"	
				rang = "tour"
				end
				if (weapon == "contact glacial") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"
				rang = "tour"
				end
				if (weapon == "glas funèbre") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"	
				rang = "tour"
				end
				if (weapon == "stabilisation") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "contrôle des flammes") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "druidisme") then hit = ""		
				damage = "0" 
				rang = "tour"
				end
				if (weapon == "façonnage de l'eau") then hit = ""		
				damage = "0"	
				rang = "tour"
				end
				if (weapon == "façonnage de la terre") then hit = "" 	
				damage = "0"
				rang = "tour"
				end
				if (weapon == "fouet épineux") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"	
				rang = "tour"
				end
				if (weapon == "gourdin magique") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d8"	
				rang = "tour"
				end
				if (weapon == "message") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "pierre magique") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d6"	
				rang = "tour"
				end

				if (weapon == "prestidigitation") then hit = ""		
				rang = "tour"
				damage = "0"	end
				if (weapon == "rafale de vent") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "réparation") then hit = ""		
				damage = "0"
				rang = "tour"
				end
				if (weapon == "sauvagerie primitive") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise)		
				damage = tostring(1+dadd) .. "d10"	
				rang = "tour"
				end
				if (weapon == "thaumaturgie") then hit = ""				
				damage = "0"
				rang = "tour"
				end
	
			if (weapon == "maléfice") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d6"        
			rang = "niveau 1 –  1 action bonus" end
			if (weapon == "éclair de chaos") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "2d8 "        
			rang = "Niveau 1 1 action" end
			if (weapon == "éclair de sorcière") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d12"        
			rang = "Niveau 1 1 action" end
			if (weapon == "éclair traçant") then hit = "1d20" .. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "4d6"        rang = "Niveau 1  1 action" end
			if (weapon == "orbe chromatique") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "3d8"        rang = "Niveau 1- 1 action" end
			if (weapon == "projectile élémentaire") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "2d8"        rang = "Niveau 1 1 action" end
			if (weapon == "projectile magique") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d4+1"        rang = "Niveau 1   1 action" end
			if (weapon == "arme spirituelle") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d8"        rang = "Niveau 2 – 1 action bonus" end
			if (weapon == "flèche acide de melf") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "4d4+2d4"        rang = "Niveau 2  1 action" end
			if (weapon == "lame de feu") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "3d6"        rang = "Niveau 2  1 action bonus" end
			if (weapon == "rayon ardent") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "2d6"        rang = "Niveau 2  1 action" end
			if (weapon == "couronne d'étoiles") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "28d12"        rang = "Niveau 7 – 1 action" end
			if (weapon == "épée de mordenkainen") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "3d10"        rang = "Niveau 7 1 action" end
			if (weapon == "couteau de glace") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "2d6"        rang = "Niveau 1 –  1 action (jds dex)" end
			if (weapon == "chien garde mordenkainen") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "4d8"        rang = "Niveau 4 -  1 action" end
			if (weapon == "blessure") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "3d10"        rang = "Niveau 1   1 action" end
			if (weapon == "rayon empoisonné") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "2d8"        rang = "Niveau 1 –  1 action" end
			if (weapon == "toucher du vampire") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "3d6"        rang = "Niveau 3 –  1 action" end
			if (weapon == "contagion") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "0"        rang = "Niveau 5 –  1 action" end
			if (weapon == "modification d'apparence") then hit = "1d20+1".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d6+1"        rang = "niveau 2 - 1 action" end
			if (weapon == "arme élémentaire") then hit = "1d20+1".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d4"        rang = "niveau 3 - 1 action" end
			if (weapon == "flèche de foudre") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "4d8"        rang = "niveau 3 - 1 action" end
			if (weapon == "flèches enflammées") then hit = "1d20".. donjons.abilityMod(ab["int"]).. "+" .. tostring(maitrise) 
			damage = "1d6"        rang = "niveau 3 - 1 action" end
			if (weapon == "animation d'objets TP") then hit = "1d20+8" 
			damage = "1d4+4"        rang = "niveau 5 - 1 action" end
			if (weapon == "animation d'objets P") then hit = "1d20+6"
			damage = "1d8+2"        rang = "niveau 5 - 1 action" end
			if (weapon == "animation d'objets M") then hit = "1d20+5" 
			damage = "2d6+1"        rang = "niveau 5 - 1 action" end
			if (weapon == "animation d'objets G") then hit = "1d20+6" 
			damage = "2d10+2"        rang = "niveau 5 - 1 action" end
			if (weapon == "animation d'objets TG") then hit = "1d20+8" 
			damage = "2d12+4"        rang = "niveau 5 - 1 action" 
			end
	
	-- modifications sorts 1 à 9 sans toucher
				if (weapon == "absorption des éléments") then hit = "" damage = "1d6"      rang = "niveau 1 -  reaction "  end
				if (weapon == "alarme") then hit = "" damage = ""      rang = "niveau 1 -  (rituel) "  end
				if (weapon == "armure d'agathys") then hit = "" damage = "5"      rang = "niveau 1 -  "  end
				if (weapon == "armure de mage") then hit = "" damage = ""      rang = "niveau 1 -   CA = 13+Mod.Dex. "  end
				if (weapon == "bouclier") then hit = "" damage = ""      rang = "niveau 1 - réaction  "  end
				if (weapon == "bouclier de la foi") then hit = "" damage = ""      rang = "niveau 1 - action bonus "  end
				if (weapon == "cérémonie") then hit = "" damage = ""      rang = "niveau 1 -  (rituel) "  end
				if (weapon == "collet") then hit = "" damage = ""      rang = "niveau 1 - 1min JdS Dex "  end
				if (weapon == "protection contre le mal et le bien") then hit = "" damage = ""      rang = "niveau 1 -  "  end
				if (weapon == "sanctuaire") then hit = "" damage = ""      rang = "niveau 1 - action bonus "  end
				if (weapon == "aide") then hit = "" damage = ""      rang = "niveau 2 - +5pv par rang de sort "  end
				if (weapon == "lien de protection") then hit = "" damage = ""      rang = "niveau 2 -  "  end
				if (weapon == "passage sans trace") then hit = "" damage = ""      rang = "niveau 2 - +10 jet dex "  end
				if (weapon == "protection contre le poison") then hit = "" damage = ""      rang = "niveau 2 - avantage sur JdS "  end
				if (weapon == "restauration partielle") then hit = "" damage = ""      rang = "niveau 2 -  "  end
				if (weapon == "verrou magique") then hit = "" damage = ""      rang = "niveau 2 -  "  end
				if (weapon == "cercle magique") then hit = "" damage = ""      rang = "niveau 3 - 1 min "  end
				if (weapon == "contresort") then hit = "" damage = ""      rang = "niveau 3 - reaction JdS Int  sort >=n4 "  end
				if (weapon == "délivrance des malédictions") then hit = "" damage = ""      rang = "niveau 3 -  "  end
				if (weapon == "dissipation de la magie") then hit = "" damage = ""      rang = "niveau 3 -  "  end
				if (weapon == "glyphe de protection") then hit = "" damage = "5d8"      rang = "niveau 3 - 1h "  end
				if (weapon == "lueur d'espoir") then hit = "" damage = ""      rang = "niveau 3 -  "  end
				if (weapon == "non-détection") then hit = "" damage = ""      rang = "niveau 3 -  "  end
				if (weapon == "protection contre une énergie") then hit = "" damage = ""      rang = "niveau 3 -  "  end
				if (weapon == "aura de pureté") then hit = "" damage = ""      rang = "niveau 4 -  "  end
				if (weapon == "aura de vie") then hit = "" damage = ""      rang = "niveau 4 -  "  end
				if (weapon == "bannissement ") then hit = "" damage = ""      rang = "niveau 4 - (JdS cha) "  end
				if (weapon == "liberté de mouvement") then hit = "" damage = ""      rang = "niveau 4 -  "  end
				if (weapon == "peau de pierre") then hit = "" damage = ""      rang = "niveau 4 -  "  end
				if (weapon == "protection contre la mort") then hit = "" damage = ""      rang = "niveau 4 -  "  end
				if (weapon == "sanctuaire privé de mordenkainen") then hit = "" damage = ""      rang = "niveau 4 - 10 min "  end
				if (weapon == "cercle de pouvoir") then hit = "" damage = ""      rang = "niveau 5 -  "  end
				if (weapon == "châtiment de bannissement") then hit = "" damage = "5d10"      rang = "niveau 5 - (+ degats arme) "  end
				if (weapon == "contrat") then hit = "" damage = ""      rang = "niveau 5 - JdS Cha "  end
				if (weapon == "coquille antivie") then hit = "" damage = ""      rang = "niveau 5 -  "  end
				if (weapon == "dissipation du mal et du bien") then hit = "" damage = ""      rang = "niveau 5 - JdS Cha "  end
				if (weapon == "restauration supérieure") then hit = "" damage = ""      rang = "niveau 5 -  "  end
				if (weapon == "bosquet des druides") then hit = "" damage = ""      rang = "niveau 6 -  "  end
				if (weapon == "globe d'invulnérabilité") then hit = "" damage = ""      rang = "niveau 6 -  "  end
				if (weapon == "interdiction") then hit = "" damage = "5d10"      rang = "niveau 6 -  (rituel) "  end
				if (weapon == "protection primordiale") then hit = "" damage = ""      rang = "niveau 6 -  "  end
				if (weapon == "protections et sceaux") then hit = "" damage = ""      rang = "niveau 6 -  "  end
				if (weapon == "symbole") then hit = "" damage = "10d10"      rang = "niveau 7 -  "  end
				if (weapon == "aura sacrée") then hit = "" damage = ""      rang = "niveau 8 -  "  end
				if (weapon == "champ antimagie") then hit = "" damage = ""      rang = "niveau 8 -  "  end
				if (weapon == "esprit impénétrable") then hit = "" damage = ""      rang = "niveau 8 -  "  end
				if (weapon == "emprisonnement") then hit = "" damage = ""      rang = "niveau 9 - JdS Sag "  end
				if (weapon == "invulnérabilité") then hit = "" damage = ""      rang = "niveau 9 -  "  end
				if (weapon == "mur prismatique") then hit = "" damage = "10d6"      rang = "niveau 9 - JdS Dex "  end
				if (weapon == "amitié avec les animaux") then hit = "" damage = ""      rang = "niveau 1 –  1 action "  end
				if (weapon == "bénédiction") then hit = "" damage = ""      rang = "niveau 1 –  1 action "  end
				if (weapon == "charme-personne") then hit = "" damage = ""      rang = "niveau 1 –  1 action (jds sag) "  end
				if (weapon == "duel forcé") then hit = "" damage = ""      rang = "niveau 1 - 1 action bonus (jds sag) "  end
				if (weapon == "fléau") then hit = "" damage = ""      rang = "niveau 1 –  1 action  (jds cha) "  end
				if (weapon == "fou rire de tasha") then hit = "" damage = ""      rang = "niveau 1 –  1 action (jds sag) "  end
				if (weapon == "héroïsme") then hit = "" damage = ""      rang = "niveau 1 -  1 action "  end
				if (weapon == "injonction") then hit = "" damage = ""      rang = "niveau 1  1 action (jds sag) "  end
				if (weapon == "murmures dissonants") then hit = "" damage = "3d6"      rang = "niveau 1 –  1 action (jds sag) "  end
				if (weapon == "sommeil") then hit = "" damage = "5d8"      rang = "niveau 1 –  1 action "  end
				if (weapon == "apaisement des émotions") then hit = "" damage = ""      rang = "niveau 2 –  1 action  (jds sag) "  end
				if (weapon == "couronne du dément") then hit = "" damage = ""      rang = "niveau 2 - 1 action (jds sag) "  end
				if (weapon == "envoûtement") then hit = "" damage = ""      rang = "niveau 2 –  1 action (jds sag) "  end
				if (weapon == "immobilisation de personne") then hit = "" damage = ""      rang = "niveau 2 –  1 action (jds sag) "  end
				if (weapon == "messager animal") then hit = "" damage = ""      rang = "niveau 2 -  (rituel) 1 action "  end
				if (weapon == "suggestion") then hit = "" damage = ""      rang = "niveau 2 –  1action (jds sag) "  end
				if (weapon == "zone de vérité") then hit = "" damage = ""      rang = "niveau 2 –  1 action "  end
				if (weapon == "ennemis à foison") then hit = "" damage = ""      rang = "niveau 3 –  1 action (jds int) "  end
				if (weapon == "sieste") then hit = "" damage = ""      rang = "niveau 3 –  1 action "  end
				if (weapon == "charme-monstre") then hit = "" damage = ""      rang = "niveau 4 –  1 action  (jds sag) "  end
				if (weapon == "compulsion") then hit = "" damage = ""      rang = "niveau 4 –  1 action  (jds sag) "  end
				if (weapon == "confusion") then hit = "" damage = ""      rang = "niveau 4 –  1 action  (jds sag) "  end
				if (weapon == "domination de bête") then hit = "" damage = ""      rang = "niveau 4 –  1 action  (jds sag) "  end
				if (weapon == "domination d'humanoïde") then hit = "" damage = ""      rang = "niveau 5 –   1 action "  end
				if (weapon == "immobilisation de monstre") then hit = "" damage = ""      rang = "niveau 5 - 1 action (jds sag) "  end
				if (weapon == "mission") then hit = "" damage = "5d10"      rang = "niveau 5 –  1 minute (jds sag) "  end
				if (weapon == "modification de mémoire") then hit = "" damage = ""      rang = "niveau 5 –  1 action (jds sag) "  end
				if (weapon == "perturbations synaptiques") then hit = "" damage = "8d6"      rang = "niveau 5 –  1 action  (jds int) "  end
				if (weapon == "danse irrésistible d'otto") then hit = "" damage = ""      rang = "niveau 6   1 action (jds sag) "  end
				if (weapon == "suggestion de groupe") then hit = "" damage = ""      rang = "niveau 6 –  1 action (jds sag) "  end
				if (weapon == "mot de pouvoir douloureux") then hit = "" damage = ""      rang = "niveau 7 –  1 action (jds con "  end
				if (weapon == "domination de monstre") then hit = "" damage = ""      rang = "niveau 8 –  1 action (jds sag) "  end
				if (weapon == "esprit faible") then hit = "" damage = "4d6"      rang = "niveau 8 –  1 action (jds sag) "  end
				if (weapon == "mot de pouvoir étourdissant") then hit = "" damage = ""      rang = "niveau 8 –  1 action (jds con) "  end
				if (weapon == "répulsion/attirance") then hit = "" damage = ""      rang = "niveau 8 –  1 heure (jds sag) "  end
				if (weapon == "hurlement psychique") then hit = "" damage = "14d6"      rang = "niveau 9 –  1 action  (jds int) "  end
				if (weapon == "mot de pouvoir mortel") then hit = "" damage = ""      rang = "niveau 9 –  1 action "  end
				if (weapon == "communication avec les animaux") then hit = "" damage = ""      rang = "niveau 1 -  (rituel)  1 action "  end
				if (weapon == "compréhension des langues") then hit = "" damage = ""      rang = "niveau 1 -  (rituel)  1 action "  end
				if (weapon == "détection de la magie") then hit = "" damage = ""      rang = "niveau 1 -  (rituel) : 1 action "  end
				if (weapon == "détection du mal et du bien") then hit = "" damage = ""      rang = "niveau 1 –  : 1 action "  end
				if (weapon == "détection du poison et des maladies") then hit = "" damage = ""      rang = "niveau 1 -  (rituel) 1 action "  end
				if (weapon == "identification") then hit = "" damage = ""      rang = "niveau 1 -  (rituel)  1 minute "  end
				if (weapon == "lien avec une bête") then hit = "" damage = ""      rang = "niveau 1 –  1 action "  end
				if (weapon == "marque du chasseur") then hit = "" damage = "1d6"      rang = "niveau 1 –   1 action bonus "  end
				if (weapon == "augure") then hit = "" damage = ""      rang = "niveau 2 -  (rituel)  1 minute "  end
				if (weapon == "détection des pensées") then hit = "" damage = ""      rang = "niveau 2 –  1 action  (jds sag) "  end
				if (weapon == "épine mentale") then hit = "" damage = "3d8"      rang = "niveau 2 –  1 action  (jds sag) "  end
				if (weapon == "localisation d'animaux ou de plantes") then hit = "" damage = ""      rang = "niveau 2 -  (rituel)  1 action "  end
				if (weapon == "localisation d'objet") then hit = "" damage = ""      rang = "niveau 2 –  1 action "  end
				if (weapon == "sens animal") then hit = "" damage = ""      rang = "niveau 2 -  (rituel)  1 action "  end
				if (weapon == "sens des pièges") then hit = "" damage = ""      rang = "niveau 2 –   1 action "  end
				if (weapon == "voir l'invisible") then hit = "" damage = ""      rang = "niveau 2 –  1 action "  end
				if (weapon == "clairvoyance") then hit = "" damage = ""      rang = "niveau 3 –   10 minutes "  end
				if (weapon == "langues") then hit = "" damage = ""      rang = "niveau 3 –   1 action "  end
				if (weapon == "divination") then hit = "" damage = ""      rang = "niveau 4 -  (rituel)  1 action "  end
				if (weapon == "localisation de créature") then hit = "" damage = ""      rang = "niveau 4 –   1 action "  end
				if (weapon == "oeil magique") then hit = "" damage = ""      rang = "niveau 4 –  1 action "  end
				if (weapon == "communion") then hit = "" damage = ""      rang = "niveau 5 -  (rituel)  1 minute "  end
				if (weapon == "communion avec la nature") then hit = "" damage = ""      rang = "niveau 5 -  (rituel) 1 minute "  end
				if (weapon == "contact avec un autre plan ") then hit = "" damage = "6d6"      rang = "niveau 5 -  (rituel) 1 minute (jds int) "  end
				if (weapon == "légende") then hit = "" damage = ""      rang = "niveau 5 –   10 minutes "  end
				if (weapon == "lien télépathique de rary") then hit = "" damage = ""      rang = "niveau 5 -  (rituel)  1 action "  end
				if (weapon == "scrutation ") then hit = "" damage = ""      rang = "niveau 5 –   10 minutes (jds sag) "  end
				if (weapon == "sens de l'orientation") then hit = "" damage = ""      rang = "niveau 6 –   1 minute "  end
				if (weapon == "vision suprême") then hit = "" damage = ""      rang = "niveau 6 –   1 action "  end
				if (weapon == "prémonition") then hit = "" damage = ""      rang = "niveau 9 –  1 minute "  end
				if (weapon == "châtiment ardent") then hit = "" damage = "1d6"      rang = "niveau 1 – 1 action bonus "  end
				if (weapon == "châtiment colérique") then hit = "" damage = "1d6 "      rang = "niveau 1 – 1 action bonus (jds sag) "  end
				if (weapon == "châtiment tonitruant") then hit = "" damage = "2d6 "      rang = "niveau 1 – 1 action bonus (jds for) "  end
				if (weapon == "faveur divine") then hit = "" damage = "1d4"      rang = "niveau 1 1 action bonus "  end
				if (weapon == "lueurs féeriques") then hit = "" damage = ""      rang = "niveau 1  1 action (jds dex) "  end
				if (weapon == "mains brûlantes") then hit = "" damage = "3d6 "      rang = "niveau 1 évocation  (jds dex) "  end
				if (weapon == "mot de guérison") then hit = "" damage = "1d4"      rang = "niveau 1  1 action bonus  "  end
				if (weapon == "onde de choc") then hit = "" damage = "2d8"      rang = "niveau 1 1 action (jds con) "  end
				if (weapon == "représailles infernales") then hit = "" damage = "2d10 "      rang = "niveau 1   1 réaction  (jds dex) "  end
				if (weapon == "secousse sismique") then hit = "" damage = "1d6 "      rang = "niveau 1 1 action (jds dex) "  end
				if (weapon == "soins") then hit = "" damage = "1d8"      rang = "niveau 1  1 action "  end
				if (weapon == "vents contraires") then hit = "" damage = ""      rang = "niveau 1  1 réaction "  end
				if (weapon == "bourrasque") then hit = "" damage = ""      rang = "niveau 2 – 1 action (jds for) "  end
				if (weapon == "châtiment lumineux") then hit = "" damage = "2d6"      rang = "niveau 2 – 1 action bonus "  end
				if (weapon == "flambée d'aganazzar") then hit = "" damage = "3d8"      rang = "niveau 2  1 action  (jds dex) "  end
				if (weapon == "flamme éternelle") then hit = "" damage = ""      rang = "niveau 2  1 action "  end
				if (weapon == "fracassement") then hit = "" damage = "3d8"      rang = "niveau 2- 1 action (jds con) "  end
				if (weapon == "nuée de boules de neige de snilloc") then hit = "" damage = "3d6"      rang = "niveau 2 1 action (jds dex) "  end
				if (weapon == "prière de guérison") then hit = "" damage = "2d8"      rang = "niveau 2 10 minutes "  end
				if (weapon == "rayon de lune") then hit = "" damage = "2d10"      rang = "niveau 2  1 action (jds con) "  end
				if (weapon == "ténèbres") then hit = "" damage = ""      rang = "niveau 2  1 action "  end
				if (weapon == "vent protecteur") then hit = "" damage = ""      rang = "niveau 2  1 action "  end
				if (weapon == "aura de vitalité") then hit = "" damage = "2d6"      rang = "niveau 3 – 1 action "  end
				if (weapon == "aura du croisé") then hit = "" damage = "1d4"      rang = "niveau 3 - 1 action "  end
				if (weapon == "boule de feu") then hit = "" damage = "8d6"      rang = "niveau 3 – 1 action (jds dex) "  end
				if (weapon == "châtiment aveuglant") then hit = "" damage = "3d8"      rang = "niveau 3– 1 action bonus  (jds con) "  end
				if (weapon == "communication à distance") then hit = "" damage = ""      rang = "niveau 3 – 1 action "  end
				if (weapon == "éclair") then hit = "" damage = "8d6"      rang = "niveau 3 – 1 action (jds dex) "  end
				if (weapon == "lumière du jour") then hit = "" damage = ""      rang = "niveau 3 1 action "  end
				if (weapon == "minuscules météores de melf") then hit = "" damage = "2d6"      rang = "niveau 3 1 action (jds dex) "  end
				if (weapon == "mot de guérison de groupe") then hit = "" damage = "1d4"      rang = "niveau 3  1 action bonus "  end
				if (weapon == "mur d'eau") then hit = "" damage = ""      rang = "niveau 3 1 action "  end
				if (weapon == "mur de sable") then hit = "" damage = ""      rang = "niveau 3 1 action "  end
				if (weapon == "mur de vent") then hit = "" damage = "3d8"      rang = "niveau 3 1 action "  end
				if (weapon == "petite hutte de léomund") then hit = "" damage = ""      rang = "niveau 3  (rituel) 1 minute "  end
				if (weapon == "bouclier de feu") then hit = "" damage = "2d8"      rang = "niveau 4 – 1 action "  end
				if (weapon == "châtiment assommant") then hit = "" damage = "4d6"      rang = "niveau 4 – 1 action bonus (jds sag) "  end
				if (weapon == "mur de feu") then hit = "" damage = "5d8"      rang = "niveau 4  1 action "  end
				if (weapon == "sphère de tempête") then hit = "" damage = "2d6+4d6"      rang = "niveau 4 1 action (jds for) "  end
				if (weapon == "sphère de vitriol") then hit = "" damage = "10d4+5d4 "      rang = "niveau 4 1 action (jds dex) "  end
				if (weapon == "sphère résiliente d'otiluke") then hit = "" damage = ""      rang = "niveau 4  1 action (jds dex) "  end
				if (weapon == "tempête de grêle") then hit = "" damage = "2d8+4d6"      rang = "niveau 4  1 action (jds dex) "  end
				if (weapon == "arme sacrée") then hit = "" damage = "2d8+4d8"      rang = "niveau 5 -  1 action bonus (jds dex) "  end
				if (weapon == "aube") then hit = "" damage = "4d10"      rang = "niveau 5 – 1 action  (jds con) "  end
				if (weapon == "colonne de flamme") then hit = "" damage = "4d6+4d6"      rang = "niveau 5  1 action (jds dex) "  end
				if (weapon == "cône de froid") then hit = "" damage = "8d8"      rang = "niveau 5 – 1 action (jds for) "  end
				if (weapon == "immolation") then hit = "" damage = "8d6"      rang = "niveau 5 1 action (jds dex) "  end
				if (weapon == "maelström") then hit = "" damage = "6d6"      rang = "niveau 5 1 action (jds for) "  end
				if (weapon == "main de bigby") then hit = "" damage = "4d8"      rang = "niveau 5 1 action "  end
				if (weapon == "mur de force") then hit = "" damage = ""      rang = "niveau 5 1 action "  end
				if (weapon == "mur de lumière") then hit = "" damage = "4d8"      rang = "niveau 5 1 action "  end
				if (weapon == "mur de pierre") then hit = "" damage = ""      rang = "niveau 5 – 1 action "  end
				if (weapon == "sanctification") then hit = "" damage = ""      rang = "niveau 5  24 heures "  end
				if (weapon == "soins de groupe") then hit = "" damage = "3d8"      rang = "niveau 5 1 action "  end
				if (weapon == "vague destructrice") then hit = "" damage = "5d6 +5d6"      rang = "niveau 5  1 action (jds con) "  end
				if (weapon == "barrière de lames") then hit = "" damage = "6d10"      rang = "niveau 6 – 1 action JdS dex "  end
				if (weapon == "chaîne d'éclairs") then hit = "" damage = "10d8"      rang = "niveau 6 – 1 action (jds dex) "  end
				if (weapon == "guérison") then hit = "" damage = "70"      rang = "niveau 6 1 action  "  end
				if (weapon == "mur de glace") then hit = "" damage = "10d6"      rang = "niveau 6  1 action JdS Dex "  end
				if (weapon == "prévoyance") then hit = "" damage = ""      rang = "niveau 6  10 minutes "  end
				if (weapon == "rayon de soleil") then hit = "" damage = "6d8"      rang = "niveau 6  1 action (jds con) "  end
				if (weapon == "sphère glaciale d'otiluke") then hit = "" damage = "10d6"      rang = "niveau 6   1 action (jds con) "  end
				if (weapon == "boule de feu à retardement") then hit = "" damage = "12d6"      rang = "niveau 7  1 action (jds dex) "  end
				if (weapon == "cage de force") then hit = "" damage = ""      rang = "niveau 7  1 action JdS Cha "  end
				if (weapon == "parole divine") then hit = "" damage = ""      rang = "niveau 7  1 action bonus (jds cha) "  end
				if (weapon == "rayons prismatiques") then hit = "" damage = "10d6"      rang = "niveau 7  1 action (jds dex) "  end
				if (weapon == "tempête de feu") then hit = "" damage = "7d10"      rang = "niveau 7  1 action (jds dex) "  end
				if (weapon == "tourbillon") then hit = "" damage = "10d6"      rang = "niveau 7 – 1 action (jds dex) "  end
				if (weapon == "éclat du soleil") then hit = "" damage = "12d6"      rang = "niveau 8  1 action (jds con) "  end
				if (weapon == "télépathie") then hit = "" damage = ""      rang = "niveau 8  1 action "  end
				if (weapon == "ténèbres oppressantes") then hit = "" damage = "8d8"      rang = "niveau 8 – 1 action (jds sag) "  end
				if (weapon == "tremblement de terre") then hit = "" damage = "5d6"      rang = "niveau 8  1 action (jds dex) "  end
				if (weapon == "guérison de groupe") then hit = "" damage = ""      rang = "niveau 9  1 action "  end
				if (weapon == "mot de pouvoir guérisseur") then hit = "" damage = ""      rang = "niveau 9 évocation1 action "  end
				if (weapon == "nuée de météores") then hit = "" damage = "20d6+20d6"      rang = "niveau 9  1 action (jds dex) "  end
				if (weapon == "couleurs dansantes") then hit = "" damage = "6d10"      rang = "niveau 1   1 action "  end
				if (weapon == "déguisement") then hit = "" damage = ""      rang = "niveau 1   1 action "  end
				if (weapon == "image silencieuse") then hit = "" damage = ""      rang = "niveau 1   1 action "  end
				if (weapon == "texte illusoire") then hit = "" damage = ""      rang = "niveau 1   (rituel) 1 min "  end
				if (weapon == "aura magique de nystul") then hit = "" damage = ""      rang = "niveau 2 –  1 action "  end
				if (weapon == "bouche magique") then hit = "" damage = ""      rang = "niveau 2  (rituel)1 min "  end
				if (weapon == "flou") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "force fantasmagorique") then hit = "" damage = ""      rang = "niveau 2 –  1 action (jds int) "  end
				if (weapon == "image miroir") then hit = "" damage = ""      rang = "niveau 2 –  1 action "  end
				if (weapon == "invisibilite") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "lame d'ombres") then hit = "" damage = "2d8"      rang = "niv 2 - 1 action bonus "  end
				if (weapon == "silence") then hit = "" damage = ""      rang = "niv 2   (rituel)1 action "  end
				if (weapon == "image majeure") then hit = "" damage = ""      rang = "niveau 3 - 1 action JdS Int "  end
				if (weapon == "monture fantôme") then hit = "" damage = ""      rang = "niveau 3 –  1 min "  end
				if (weapon == "motif hypnotique") then hit = "" damage = ""      rang = "niveau 3 - 1 action (jds sag) "  end
				if (weapon == "peur") then hit = "" damage = ""      rang = "niveau 3 - 1 action (jds sag) "  end
				if (weapon == "assassin imaginaire") then hit = "" damage = "4d10"      rang = "niveau 4 –  1 action  (jds sag) "  end
				if (weapon == "invisibilité supérieure") then hit = "" damage = ""      rang = "niveau 4 -  1 action "  end
				if (weapon == "terrain hallucinatoire") then hit = "" damage = ""      rang = "niveau 4 –  10 min JdS Invest "  end
				if (weapon == "apparence trompeuse") then hit = "" damage = ""      rang = "niveau 5 –  1 action (jds sag) "  end
				if (weapon == "création") then hit = "" damage = ""      rang = "niveau 5 –  1 minute "  end
				if (weapon == "double illusoire") then hit = "" damage = ""      rang = "niveau 5 –  1 action "  end
				if (weapon == "rêve") then hit = "" damage = "3d6"      rang = "niveau 5 - 1 minute (jds sag) "  end
				if (weapon == "illusion programmée") then hit = "" damage = ""      rang = "niveau 6 –  1 action "  end
				if (weapon == "prison mentale") then hit = "" damage = "5d10"      rang = "niveau 6 –  1 action (jds int) "  end
				if (weapon == "mirage") then hit = "" damage = ""      rang = "niveau 7 -  10 minutes "  end
				if (weapon == "projection d'image") then hit = "" damage = ""      rang = "niveau 7 - 1 action "  end
				if (weapon == "simulacre") then hit = "" damage = ""      rang = "niveau 7 –  12 heures "  end
				if (weapon == "dragon illusoire") then hit = "" damage = ""      rang = "niveau 8 –  1 action (jds sag) "  end
				if (weapon == "ennemi subconscient") then hit = "" damage = "4d10"      rang = "niveau 9 –  1 action (jds sag) "  end
				if (weapon == "appel de familier") then hit = "" damage = ""      rang = "niveau 1 -   1 h "  end
				if (weapon == "disque flottant de tenser") then hit = "" damage = ""      rang = "niveau 1 -  1 action "  end
				if (weapon == "enchevêtrement") then hit = "" damage = ""      rang = "niveau 1 –  1 action (jds for) "  end
				if (weapon == "frappe piégeante") then hit = "" damage = "1d6"      rang = "niv 1 - 1 action bonus (jds for) "  end
				if (weapon == "graisse") then hit = "" damage = ""      rang = "niveau 1 –  1 action (jds dex) "  end
				if (weapon == "grêle d'épines") then hit = "" damage = "1d10"      rang = "niv 1 –  1 action bonus (jds dex) "  end
				if (weapon == "nappe de brouillard") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "serviteur invisible") then hit = "" damage = ""      rang = "niveau 1 –  1 action "  end
				if (weapon == "tentacules de hadar") then hit = "" damage = "2d6"      rang = "niveau 1 -  1 action (jds for) "  end
				if (weapon == "appel de monture") then hit = "" damage = ""      rang = "niveau 2 –   10 minutes "  end
				if (weapon == "esprit guérisseur") then hit = "" damage = "1d6"      rang = "niv 2 –  1 action bonus "  end
				if (weapon == "nuée de dagues") then hit = "" damage = "4d4"      rang = "niveau 2 - 1 action "  end
				if (weapon == "pas brumeux") then hit = "" damage = ""      rang = "niv 2 –  1 action bonus "  end
				if (weapon == "sphère de feu") then hit = "" damage = "2d6"      rang = "niveau 2 -  1 action (jds dex) "  end
				if (weapon == "toile d'araignée") then hit = "" damage = "2d4"      rang = "niveau 2 –  1 action (jds dex) "  end
				if (weapon == "tourbillon de poussière") then hit = "" damage = "1d8"      rang = "niveau 2 -  1 action (jds for) "  end
				if (weapon == "appel de la foudre") then hit = "" damage = "3d10"      rang = "niveau 3 –  1 action (jds dex) "  end
				if (weapon == "création nourriture eau") then hit = "" damage = ""      rang = "niveau 3 –   1 action "  end
				if (weapon == "esprits gardiens") then hit = "" damage = "3d8"      rang = "niveau 3 –  1 action (jds sag) "  end
				if (weapon == "faim inextinguible hadar") then hit = "" damage = "2d6+2d6"      rang = "niveau 3 -  1 action (jds dex) "  end
				if (weapon == " invocation d'animaux") then hit = "" damage = ""      rang = "niveau 3 –  1 action "  end
				if (weapon == " invocation démons inf") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == " tir de barrage") then hit = "" damage = "3d8"      rang = "niveau 3 –  1 action "  end
				if (weapon == "nuage puant") then hit = "" damage = "5d8"      rang = "niveau 3 –   1 action (jds con) "  end
				if (weapon == "raz-de-marée") then hit = "" damage = "4d8"      rang = "niveau 3 –  1 action (jds dex) "  end
				if (weapon == "tempête de neige") then hit = "" damage = ""      rang = "niveau 3 –  1 action (jds dex) "  end
				if (weapon == "coffre secret de léomund") then hit = "" damage = ""      rang = "niveau 4 - 1 action "  end
				if (weapon == "gardien de la foi") then hit = "" damage = "20"      rang = "niveau 4 –  1 action JdS Dex "  end
				if (weapon == "invocation d'élémentaires mineurs") then hit = "" damage = ""      rang = "niveau 4 –  1 minute "  end
				if (weapon == "invocation d'êtres des bois") then hit = "" damage = ""      rang = "niveau 4 –  1 action "  end
				if (weapon == "invocation de démon supérieur") then hit = "" damage = ""      rang = "niveau 4 –   1 action "  end
				if (weapon == "liane agrippeuse") then hit = "" damage = ""      rang = "niv 4 –  1 action bonus (jds dex) "  end
				if (weapon == "porte dimensionnelle") then hit = "" damage = ""      rang = "niveau 4 –  1action "  end
				if (weapon == "sphère aqueuse") then hit = "" damage = ""      rang = "niveau 4 –  1 action (jds for) "  end
				if (weapon == "tentacules noirs d'evard") then hit = "" damage = "3d6"      rang = "niveau 4 –  1 action (jds dex) "  end
				if (weapon == "cercle de téléportation") then hit = "" damage = ""      rang = "niveau 5 –  1 minute "  end
				if (weapon == "fléau d'insectes") then hit = "" damage = "4d10"      rang = "niveau 5 –  1action (jds con) "  end
				if (weapon == "invocation d'élémentaire") then hit = "" damage = ""      rang = "niveau 5 –  1 minute "  end
				if (weapon == "volée projectiles") then hit = "" damage = "8d8"      rang = "niveau 5 –  1 action (jds dex) "  end
				if (weapon == "nuage mortel") then hit = "" damage = "5d8"      rang = "niveau 5 –  1 action  (jds con) "  end
				if (weapon == "passage par les arbres") then hit = "" damage = ""      rang = "niveau 5 –  1 action "  end
				if (weapon == "allié planaire") then hit = "" damage = ""      rang = "niveau 6 –   10 minutes "  end
				if (weapon == "diversion") then hit = "" damage = ""      rang = "niveau 6 –  1 action (jds sag) "  end
				if (weapon == "festin des héros") then hit = "" damage = ""      rang = "niveau 6 –  10 minutes "  end
				if (weapon == "invocation de fée") then hit = "" damage = ""      rang = "niveau 6 –  1 minute "  end
				if (weapon == "invocations instantanées de drawmij") then hit = "" damage = ""      rang = "niveau 6 –  1 minute "  end
				if (weapon == "mot de rappel") then hit = "" damage = ""      rang = "niveau 6 –  1 action "  end
				if (weapon == "mur d'épines") then hit = "" damage = "7d8"      rang = "niveau 6 –  1 action JdS dex "  end
				if (weapon == "portail magique") then hit = "" damage = ""      rang = "niveau 6 –  1 action "  end
				if (weapon == "transport par les plantes") then hit = "" damage = ""      rang = "niveau 6 –   1 action "  end
				if (weapon == "changement de plan") then hit = "" damage = ""      rang = "niveau 7 –  1 action (jds cha) "  end
				if (weapon == "invocation  de céleste") then hit = "" damage = ""      rang = "niveau 7 –  1 minute "  end
				if (weapon == "manoir somptueux de mordenkainen") then hit = "" damage = ""      rang = "niveau 7   1 minute "  end
				if (weapon == "téléportation") then hit = "" damage = ""      rang = "niveau 7 –  1 action "  end
				if (weapon == "temple des dieux") then hit = "" damage = ""      rang = "niveau 7 –  1 heure "  end
				if (weapon == "demi-plan") then hit = "" damage = ""      rang = "niveau 8 –  1 action "  end
				if (weapon == "labyrinthe") then hit = "" damage = ""      rang = "niveau 8 –  1 action (jds int) "  end
				if (weapon == "nuage incendiaire") then hit = "" damage = "10d8"      rang = "niveau 8 –  1 action (jds dex) "  end
				if (weapon == "tsunami") then hit = "" damage = "6d10"      rang = "niveau 8 -  1 minute (jds for) "  end
				if (weapon == "portail") then hit = "" damage = "5d10"      rang = "niveau 9 –  1 action "  end
				if (weapon == "souhait") then hit = "" damage = ""      rang = "niveau 9 -  1 action "  end
				if (weapon == "tempête vengeresse") then hit = "" damage = "2d6+1d6+10d6+2d6+1d6"      rang = "niveau 9 –  1 action (jds con) "  end
				if (weapon == "frayeur") then hit = "" damage = ""      rang = "niveau 1 –  1 action (jds sag) "  end
				if (weapon == "simulacre de vie") then hit = "" damage = "1d4+4"      rang = "niveau 1 –  1 action "  end
				if (weapon == "cécité/surdité") then hit = "" damage = ""      rang = "niveau 2 –  1 action (jds con) "  end
				if (weapon == "préservation des morts") then hit = "" damage = ""      rang = "niveau 2 -   1 action "  end
				if (weapon == "rayon affaiblissant") then hit = "" damage = ""      rang = "niveau 2 –  1 action  (jds con) "  end
				if (weapon == "animation des morts") then hit = "" damage = ""      rang = "niveau 3 –  1 minute "  end
				if (weapon == "communication avec les morts") then hit = "" damage = ""      rang = "niveau 3 -  1 action "  end
				if (weapon == "malédiction") then hit = "" damage = "1d8"      rang = "niveau 3 –  1 action (jds sag) "  end
				if (weapon == "mort simulée") then hit = "" damage = ""      rang = "niveau 3 -  1 action "  end
				if (weapon == "réanimation") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "transfert de vie") then hit = "" damage = ""      rang = "niveau 3 –  1 action "  end
				if (weapon == "flétrissement") then hit = "" damage = "8d8"      rang = "niveau 4 –  1 action (jds con) "  end
				if (weapon == "ombre d'égarement") then hit = "" damage = "2d8"      rang = "niveau 4 –  1 action "  end
				if (weapon == "danse macabre") then hit = "" damage = ""      rang = "niveau 5 –  1 action "  end
				if (weapon == "déluge d'énergie négative") then hit = "" damage = "5d12"      rang = "niveau 5 –  1 action (jds con) "  end
				if (weapon == "énervation") then hit = "" damage = "4d8"      rang = "niveau 5 - 1 action (jds dex) "  end
				if (weapon == "rappel à la vie") then hit = "" damage = ""      rang = "niveau 5   1 heure "  end
				if (weapon == "cage des âmes") then hit = "" damage = ""      rang = "niveau 6 –  1 reaction "  end
				if (weapon == "cercle de mort") then hit = "" damage = "8d6"      rang = "niveau 6 –  1 action (jds con) "  end
				if (weapon == "contamination") then hit = "" damage = "14d6"      rang = "niveau 6 -  1 action (jds con) "  end
				if (weapon == "création de mort-vivant") then hit = "" damage = ""      rang = "niveau 6 –  1 minute "  end
				if (weapon == "mauvais oeil") then hit = "" damage = ""      rang = "niveau 6 –  1 action (jds sag) "  end
				if (weapon == "urne magique") then hit = "" damage = ""      rang = "niveau 6 –  1 minute "  end
				if (weapon == "doigt de mort") then hit = "" damage = "7d8+30"      rang = "niveau 7 - 1 action  (jds con) "  end
				if (weapon == "résurrection") then hit = "" damage = ""      rang = "niveau 7 –  1 heure "  end
				if (weapon == "clone") then hit = "" damage = ""      rang = "niveau 8 –  1 heure "  end
				if (weapon == "flétrissure épouvantable") then hit = "" damage = "12d8"      rang = "niveau 8 –  1 action (jds con) "  end
				if (weapon == "projection astrale") then hit = "" damage = ""      rang = "niveau 9 –   1 heure "  end
				if (weapon == "résurrection suprême") then hit = "" damage = ""      rang = "niveau 9 –  1 heure "  end
				if (weapon == "baies nourricières") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "catapulte") then hit = "" damage = "3d8"      rang = "niveau 1 - 1 action (jds dex) "  end
				if (weapon == "création ou destruction d'eau") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "feuille morte") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "frappe du zéphyr") then hit = "" damage = "1d8"      rang = "niveau 1 - 1 action "  end
				if (weapon == "grande foulée") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "purification de nourriture et d'eau") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "repli expéditif") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "saut") then hit = "" damage = ""      rang = "niveau 1 - 1 action "  end
				if (weapon == "agrandissement/rapetissement") then hit = "" damage = ""      rang = "niveau 2 - 1 action (jds con) "  end
				if (weapon == "amélioration de caractéristique") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "arme magique") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "attraction terrestre") then hit = "" damage = ""      rang = "niveau 2 - 1 action (jds for) "  end
				if (weapon == "corde enchantée") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "cordon de flèches") then hit = "" damage = "1d6"      rang = "niveau 2 - 1 action (jds dex) "  end
				if (weapon == "croissance d'épines") then hit = "" damage = "2d4"      rang = "niveau 2 - 1 action "  end
				if (weapon == "déblocage") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "écrire dans le ciel") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "lévitation") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "métal brûlant") then hit = "" damage = "2d8"      rang = "niveau 2 - 1 action "  end
				if (weapon == "pattes d'araignée") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "peau d'écorce") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "poigne terreuse de maximilien") then hit = "" damage = "2d6"      rang = "niveau 2 - 1 action (jds for) "  end
				if (weapon == "pyrotechnie") then hit = "" damage = ""      rang = "niveau 2 - 1 action (jds con) "  end
				if (weapon == "souffle du dragon") then hit = "" damage = "3d6"      rang = "niveau 2 - 1 action (jds dex) "  end
				if (weapon == "vision dans le noir") then hit = "" damage = ""      rang = "niveau 2 - 1 action "  end
				if (weapon == "clignotement") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "communication avec les plantes") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "croissance végétale") then hit = "" damage = ""      rang = "niveau 3 - 1 action 8h "  end
				if (weapon == "éruption de terre") then hit = "" damage = "3d12"      rang = "niveau 3 - 1 action (jds dex) "  end
				if (weapon == "forme gazeuse") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "fusion dans la pierre") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "hâte") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "lenteur") then hit = "" damage = ""      rang = "niveau 3 - 1 action (jds sag) "  end
				if (weapon == "marche sur l'eau") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "respiration aquatique") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "serviteur miniature") then hit = "" damage = ""      rang = "niveau 3 - 1 min "  end
				if (weapon == "vol") then hit = "" damage = ""      rang = "niveau 3 - 1 action "  end
				if (weapon == "contrôle de l'eau") then hit = "" damage = ""      rang = "niveau 4 - 1 action "  end
				if (weapon == "fabrication") then hit = "" damage = ""      rang = "niveau 4 - 1 action "  end
				if (weapon == "façonnage de la pierre") then hit = "" damage = ""      rang = "niveau 4 - 1 action "  end
				if (weapon == "fléau élémentaire ") then hit = "" damage = "2d6"      rang = "niveau 4 - 1 action (jds con) "  end
				if (weapon == "gardien de la nature") then hit = "" damage = ""      rang = "niveau 4 - 1 action bonus "  end
				if (weapon == "insecte géant") then hit = "" damage = ""      rang = "niveau 4 - 1 action "  end
				if (weapon == "métamorphose") then hit = "" damage = ""      rang = "niveau 4 - 1 action "  end
				if (weapon == "amélioration de compétences") then hit = "" damage = ""      rang = "niveau 5 - 1 action "  end
				if (weapon == "carquois magique") then hit = "" damage = ""      rang = "niveau 5 action bonus "  end
				if (weapon == "contrôle des vents") then hit = "" damage = ""      rang = "niveau 5 - 1 action "  end
				if (weapon == "éveil") then hit = "" damage = ""      rang = "niveau 5 - 8h "  end
				if (weapon == "passe-muraille") then hit = "" damage = ""      rang = "niveau 5 - 1 action "  end
				if (weapon == "réincarnation") then hit = "" damage = ""      rang = "niveau 5 - 1h "  end
				if (weapon == "télékinésie") then hit = "" damage = "4d8"      rang = "niveau 5 - 1 action "  end
				if (weapon == "transmutation de la pierre") then hit = "" damage = ""      rang = "niveau 5 - 1 action "  end
				if (weapon == "création d'homoncule") then hit = "" damage = ""      rang = "niveau 6 - 1 heure "  end
				if (weapon == "désintégration") then hit = "" damage = "10d6+40"      rang = "niveau 6 - 1 action (jds dex) "  end
				if (weapon == "marche sur le vent") then hit = "" damage = "6d6"      rang = "niveau 6 - 1 min "  end
				if (weapon == "ossements de la terre") then hit = "" damage = ""      rang = "niveau 6 - 1 action "  end
				if (weapon == "pétrification") then hit = "" damage = ""      rang = "niveau 6 - 1 action (jds con) "  end
				if (weapon == "sacre de la glace") then hit = "" damage = "4d6 "      rang = "niveau 6 - 1 action (jds con) "  end
				if (weapon == "sacre de la pierre") then hit = "" damage = ""      rang = "niveau 6 - 1 action (jds dex) "  end
				if (weapon == "sacre des flammes") then hit = "" damage = "4d8"      rang = "niveau 6 - 1 action (jds dex) "  end
				if (weapon == "sacre du vent") then hit = "" damage = "2d10"      rang = "niveau 6 - 1 action (jds con) "  end
				if (weapon == "terraformage") then hit = "" damage = ""      rang = "niveau 6 - 1 action "  end
				if (weapon == "transformation de tenser") then hit = "" damage = ""      rang = "niveau 6 - 1 action "  end
				if (weapon == "dissimulation") then hit = "" damage = ""      rang = "niveau 7 - 1 action "  end
				if (weapon == "forme éthérée") then hit = "" damage = ""      rang = "niveau 7 - 1 action "  end
				if (weapon == "inversion de la gravité") then hit = "" damage = ""      rang = "niveau 7 - 1 action "  end
				if (weapon == "régénération") then hit = "" damage = "4d8+15"      rang = "niveau 7 - 1 min "  end
				if (weapon == "bagou") then hit = "" damage = ""      rang = "niveau 8 - 1 action "  end
				if (weapon == "contrôle du climat") then hit = "" damage = ""      rang = "niveau 8 - 10 min "  end
				if (weapon == "formes animales") then hit = "" damage = ""      rang = "niveau 8 - 1 action "  end
				if (weapon == "arrêt du temps") then hit = "" damage = "1d4+1"      rang = "niveau 9 - 1 action "  end
				if (weapon == "changement de forme") then hit = "" damage = ""      rang = "niveau 9 - 1 action "  end
				if (weapon == "métamorphose de groupe") then hit = "" damage = ""      rang = "niveau 9 - 1 action "  end
				if (weapon == "métamorphose suprême") then hit = "" damage = ""      rang = "niveau 9 - 1 action "  end

			-- armes classiques armes lourdes en str les autres en fine 
					if (weapon == "Bâton") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Dague") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Gourdin") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hachette") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Javeline") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau léger") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Masse d'armes") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Massue") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Serpe") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète légère") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc court") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléchette") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fronde") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Cimeterre") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Coutille") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée à 2 mains") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée courte") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée longue") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléau d'armes") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fouet") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache à 2 mains") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache d'armes") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hallebarde") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance d’arçon") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Maillet") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau de guerre") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Morgenstern") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pic de guerre") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pique") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Rapière") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Trident") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète de poing") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète lourde") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc long") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Bâton+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Dague+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Gourdin+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hachette+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Javeline+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau léger+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Masse d'armes+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Massue+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Serpe+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète légère+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc court+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléchette+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fronde+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Cimeterre +1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Coutille+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée à 2 mains+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée courte+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée longue+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléau d'armes+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fouet+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache à 2 mains+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache d'armes+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hallebarde+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance d’arçon+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Maillet+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau de guerre+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Morgenstern+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pic de guerre+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pique+1") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Rapière+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Trident+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète de poing+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète lourde+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc long+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Bâton+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Dague+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Gourdin+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hachette+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Javeline+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau léger+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Masse d'armes+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Massue+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Serpe+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète légère+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc court+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléchette+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fronde+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Cimeterre+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Coutille+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée à 2 mains+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée courte+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée longue+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléau d'armes+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fouet+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache à 2 mains+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache d'armes+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hallebarde+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance d’arçon+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Maillet+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau de guerre+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Morgenstern+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pic de guerre+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pique+2") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Rapière+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Trident+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète de poing+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète lourde+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc long+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Bâton+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Dague+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Gourdin+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hachette+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Javeline+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau léger+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Masse d'armes+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Massue+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Serpe+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète légère+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc court+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléchette+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fronde+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Cimeterre+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Coutille+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d1+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée à 2 mains+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée courte+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Épée longue+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fléau d'armes+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Fouet+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache à 2 mains+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hache d'armes+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Hallebarde+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d10+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Lance d’arçon+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d12+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Maillet+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "2d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Marteau de guerre+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Morgenstern+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pic de guerre+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Pique+3") then hit = "1d20".. donjons.abilityMod(ab["str"]).. "+" .. tostring(maitrise)    damage = "1d1+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Rapière+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Trident+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète de poing+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arbalète lourde+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+3 " .. "+" .. tostring(maitrise)         rang = ""  end
					if (weapon == "Arc long+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
	
		
		
					if (weapon == "Quarterstaff") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dagger") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Club") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Handaxe") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Javelin") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Spear") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lighthammer") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Mace") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatclub") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sickle") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbow") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortbow") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dart") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sling") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Scimitar") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Glaive") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatsword") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortsword") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longsword") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Flail") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Whip") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greataxe") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Battleaxe") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Halberd") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lance") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Maul") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warhammer") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Morningstar") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warpick") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Pike") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Rapier") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Trident") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowhand") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowheavy") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longbow") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Quarterstaff+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dagger+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Club+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Handaxe+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Javelin+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Spear+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lighthammer+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Mace+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatclub+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sickle+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbow+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortbow+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dart+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sling+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Scimitar+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Glaive+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatsword+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortsword+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longsword+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Flail+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Whip+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greataxe+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Battleaxe+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Halberd+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lance+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Maul+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warhammer+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Morningstar+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warpick+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Pike+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Rapier+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Trident+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowhand+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowheavy+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+1 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longbow+1") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+1" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Quarter+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dagger+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Club+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Handaxe+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Javelin+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Spear+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lighthammer+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Mace+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatclub+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sickle+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbow+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortbow+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dart+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sling+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Scimitar+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Glaive+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatsword+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortsword+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longsword+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Flail+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Whip+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greataxe+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Battleaxe+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Halberd+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lance+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Maul+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warhammer+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Morningstar+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warpick+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Pike+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Rapier+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Trident+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowhand+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowheavy+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+2 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longbow+2") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+2" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Quarterstaff+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dagger+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Club+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Handaxe+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Javelin+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Spear+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lighthammer+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Mace+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatclub+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sickle+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbow+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortbow+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Dart+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Sling+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Scimitar+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Glaive+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d1+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greatsword+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Shortsword+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longsword+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Flail+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Whip+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d4+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Greataxe+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Battleaxe+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Halberd+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Lance+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d12+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Maul+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "2d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warhammer+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Morningstar+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Warpick+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Pike+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d1+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Rapier+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Trident+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowhand+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d6+3" .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Crossbowheavy+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d10+3 " .. "+" .. tostring(maitrise)         rang = ""  end
							if (weapon == "Longbow+3") then hit = "1d20".. donjons.abilityMod(ab["fine"]).. "+" .. tostring(maitrise)    damage = "1d8+3" .. "+" .. tostring(maitrise)         rang = ""  end
		
		
		
		
		
		
		
		
		
		
		
		
		
	return hit, damage, rang
	end

-- modification of the character sheet (see documentation or yag.lua script for details)
function donjons.My_CharacterSheetUpdate(sp, cs)
		if (cs.lines["typefiche"].string2 == "joueur") then
	-- primary variables (found in character sheet with unique identifier) int plus haute valeur entre charisme intelligence et sagesse.  fine plus haute valeur entre dex et force
			abilities = { str = tonumber(cs.lines["Z1"].extraString), dex = tonumber(cs.lines["Z2"].extraString), int = tonumber(cs.lines["magie"].formula1), fine = tonumber(math.max(cs.lines["Z1"].extraString, cs.lines["Z2"].extraString))}
			level = tonumber(cs.lines["lvl"].formula1)
			maitrise = tonumber(cs.lines["Z7"].formula1)
			dadd = tonumber(cs.lines["magie"].formula2)
		
			if tonumber(cs.lines["lvl"].formula1) < 5 then cs.lines["magie"].formula2 = tostring(0) end
			if 11 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 5  then cs.lines["magie"].formula2 = tostring(1) end
			if 17 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 11 then cs.lines["magie"].formula2 = tostring(2) end
			if tonumber(cs.lines["lvl"].formula1) >= 17 then cs.lines["magie"].formula2 = tostring(3) end
			
		else return cs
		end
		
	--Modif ZUL/grom
	-- modificateurs selon caracteristiques ok
	 if (cs.lines["typefiche"].string2 == "joueur") then
		if (cs.lines["Z1"].extraString ~= "") then
			valeur = donjons.abilityMod(tonumber(cs.lines["Z1"].extraString))
			cs.lines["Z1"].formula1 = tostring(valeur)
			cs.lines["Z8"].formula1 = tostring(valeur)
			cs.lines["Z8"].formula2 = tostring(valeur)
		end
		if (cs.lines["Z2"].extraString ~= "") then
			valeur = donjons.abilityMod(tonumber(cs.lines["Z2"].extraString))
			cs.lines["Z2"].formula1 = tostring(valeur)
			cs.lines["Z9"].formula1 = tostring(valeur)
			cs.lines["Z9"].formula2 = tostring(valeur)
		end
		if (cs.lines["Z3"].extraString ~= "") then
			valeur = donjons.abilityMod(tonumber(cs.lines["Z3"].extraString))
			cs.lines["Z3"].formula1 = tostring(valeur)
			cs.lines["Z3"].formula2 = tostring(valeur)
		end
		if (cs.lines["Z4"].extraString ~= "") then
			valeur = donjons.abilityMod(tonumber(cs.lines["Z4"].extraString))
			cs.lines["Z4"].formula1 = tostring(valeur)
		end
		if (cs.lines["Z5"].extraString ~= "") then
			valeur = donjons.abilityMod(tonumber(cs.lines["Z5"].extraString))
			cs.lines["Z5"].formula1 = tostring(valeur)
		end
		if (cs.lines["Z6"].extraString ~= "") then
			valeur = donjons.abilityMod(tonumber(cs.lines["Z6"].extraString))
			cs.lines["Z6"].formula1 = tostring(valeur)
		end
		cs.lines["magie"].formula1 = tostring(math.max(cs.lines["Z4"].extraString, cs.lines["Z5"].extraString,cs.lines["Z6"].extraString))
		cs.lines["Z10"].formula1 = tostring(math.max(cs.lines["Z4"].formula1, cs.lines["Z5"].formula1,cs.lines["Z6"].formula1))
	
	else 
	return cs
    end
		
	-- armure légère intermédiaire CA ok
	 if (cs.lines["typefiche"].string2 == "joueur") then
			if (cs.lines["def4"].extraBool == true) then
			CA = tonumber(cs.lines["Z2"].formula1) + tonumber(cs.lines["def4"].formula1) + tonumber(cs.lines["def2"].formula1) + tonumber(cs.lines["def3"].formula1)
			cs.lines["Z41"].formula1 = tostring(CA)
			end
			if (cs.lines["def1"].extraBool == true) then
			CA = tonumber(cs.lines["def1"].formula1) + tonumber(cs.lines["def2"].formula1) + tonumber(cs.lines["def3"].formula1)
			cs.lines["Z41"].formula1 = tostring(CA)
			end
			if (cs.lines["def5"].extraBool == true) then
				if (tonumber(cs.lines["Z2"].formula1) > 2) then
				CA = 2 + tonumber(cs.lines["def5"].formula1) + tonumber(cs.lines["def2"].formula1) + tonumber(cs.lines["def3"].formula1)
				else CA = tonumber(cs.lines["Z2"].formula1) + tonumber(cs.lines["def4"].formula1) + tonumber(cs.lines["def2"].formula1) + tonumber(cs.lines["def3"].formula1)
				end
			cs.lines["Z41"].formula1 = tostring(CA)
			end
			
			if (cs.lines["def6"].extraBool == true) then
			CA = 10 + tonumber(cs.lines["Z3"].formula1) + tonumber(cs.lines["Z5"].formula1)
			cs.lines["Z41"].formula1 = tostring(CA)
			end
			
			if (cs.lines["def7"].extraBool == true) then
			CA = 10 + tonumber(cs.lines["Z3"].formula1) + tonumber(cs.lines["Z2"].formula1) + tonumber(cs.lines["def2"].formula1)
			cs.lines["Z41"].formula1 = tostring(CA)
			--else CA = 10 + tonumber(cs.lines["def3"].formula1)+ tonumber(cs.lines["def2"].formula1)+ tonumber(cs.lines["Z2"].formula1)
			cs.lines["Z41"].formula1 = tostring(CA)
			end
	else 
	return cs 
	end
	
	--Modification de la richesse comme +/- ok
			po = tonumber(cs.lines["G1"].formula1)+ tonumber(cs.lines["G2"].formula1)
			cs.lines["G1"].formula1 = tostring(po)
			
			
			pa = tonumber(cs.lines["T1"].formula1)+ tonumber(cs.lines["T2"].formula1)
			cs.lines["T1"].formula1 = tostring(pa)
		
			
			pc = tonumber(cs.lines["K1"].formula1)+ tonumber(cs.lines["K2"].formula1)
			cs.lines["K1"].formula1 = tostring(pc)
		
	
	--modifications des lignes hpmax hpcurrent sur feuille de perso  ok (actualisation psid??)
		
			hp = tonumber(cs.lines["L3"].formula1) 
			modifPV = tonumber(cs.lines["L4"].formula1)
			
			if tonumber(cs.lines["L3"].formula1) > tonumber(cs.lines["L1"].formula1) then
					cs.lines["L3"].formula1 = tostring(cs.lines["L1"].formula1)
			else hpcurrent = hp + modifPV
			cs.lines["L3"].formula1 = tostring(hpcurrent)
			end
			
	
	--modification initiative 
			cs.init = "1d20" .. donjons.abilityMod(tonumber(cs.lines["Z2"].extraString))
	
	-- modification DD sorts perception
		DD = 8 + tonumber(cs.lines["Z10"].formula1)+ tonumber(cs.lines["Z7"].formula1)
		cs.lines["Z43"].formula1 = tostring(DD)
		perception = 10 + tonumber(cs.lines["Z7"].formula1)
		cs.lines["S32"].formula1 = tostring(perception)
		
	--modifications de la maîtrise  ok 
			if tonumber(cs.lines["lvl"].formula1) < 5 then cs.lines["Z7"].formula1 = tostring(2) end
			if 9 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1)>= 5  then cs.lines["Z7"].formula1 = tostring(3) end
			if 13 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 9 then cs.lines["Z7"].formula1 = tostring(4) end
			if 17 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 13 then cs.lines["Z7"].formula1 = tostring(5) end
			if tonumber(cs.lines["lvl"].formula1) >= 17 then cs.lines["Z7"].formula1 = tostring(6) end
			
	-- Rage du barbare et Ki du moine
			if tonumber(cs.lines["lvl"].formula1) < 3 then cs.lines["Z11"].extraString = tostring("Points de Rage:  " .. 2) end                                                                                                                                 
			if 6 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1)>= 3  then cs.lines["Z11"].extraString = tostring("Points de Rage:  " .. 3) end  
			if 12 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 6 then cs.lines["Z11"].extraString = tostring("Points de Rage:  " .. 4) end 
            if 17 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 12 then cs.lines["Z11"].extraString = tostring("Points de Rage: " .. 5) end
			if tonumber(cs.lines["lvl"].formula1) >= 17 then cs.lines["Z11"].extraString = tostring("Points de Rage:  " .. 6) end
			if tonumber(cs.lines["lvl"].formula1) < 9 then cs.lines["Z11"].formula1 = tostring("+2")  cs.lines["Z11"].formula2 = tostring("+2")   end
			if 16 > tonumber(cs.lines["lvl"].formula1) and tonumber(cs.lines["lvl"].formula1) >= 9  then cs.line["Z11"].formula1 = tostring("+3")   cs.line["Z11"].formula2 = tostring("+3")    end
			if tonumber(cs.lines["lvl"].formula1) >= 16 then cs.lines["Z11"].formula1 = tostring("+4")      cs.lines["Z11"].formula2 = tostring("+4") end

			
			cs.lines["Z12"].formula1 = tostring(cs.lines["lvl"].formula1)
	
	-- PV au niveau 1
			Hpl = tonumber(cs.lines["O12"].formula1)
			modifconsti = tonumber(cs.lines["Z3"].formula1)
			if (level < 2) then 
			cs.maxhp = Hpl + modifconsti
			cs.lines["L1"].formula1 = tostring(cs.maxhp)
			end

	
	--modification formule sorts combat 
	-- using the "extraString" field to identify weapons
	
			w1 = cs.lines["w1"].extraString
			w2 = cs.lines["w2"].extraString
			w3 = cs.lines["w3"].extraString
			w4 = cs.lines["w4"].extraString
			w5 = cs.lines["w5"].extraString
			w6 = cs.lines["w6"].extraString
			w7 = cs.lines["w7"].extraString
			w8 = cs.lines["w8"].extraString
			w9 = cs.lines["w9"].extraString
			w10 = cs.lines["w10"].extraString
			w11 = cs.lines["w11"].extraString
			w12 = cs.lines["w12"].extraString
			w13 = cs.lines["w13"].extraString
			w14 = cs.lines["w14"].extraString
			w15 = cs.lines["w15"].extraString
			w16 = cs.lines["w16"].extraString
			w17 = cs.lines["w17"].extraString
			w18 = cs.lines["w18"].extraString
			w19 = cs.lines["w19"].extraString
			w20 = cs.lines["w20"].extraString
			w21 = cs.lines["w21"].extraString
			w22 = cs.lines["w22"].extraString
			w23 = cs.lines["w23"].extraString
			w24 = cs.lines["w24"].extraString
			w25 = cs.lines["w25"].extraString
			w26 = cs.lines["w26"].extraString
			w27 = cs.lines["w27"].extraString
			w28 = cs.lines["w28"].extraString
			w29 = cs.lines["w29"].extraString
			w30 = cs.lines["w30"].extraString
			w31 = cs.lines["w31"].extraString
			
			yt1 = cs.lines["w1"].tab
			yt2 = cs.lines["w2"].tab
			yt3 = cs.lines["w3"].tab
			yt4 = cs.lines["w4"].tab
			yt5 = cs.lines["w5"].tab
			yt6 = cs.lines["w6"].tab
			yt7 = cs.lines["w7"].tab
			yt8 = cs.lines["w8"].tab
			yt9 = cs.lines["w9"].tab
			yt10 = cs.lines["w10"].tab
			yt11 = cs.lines["w11"].tab
			yt12 = cs.lines["w12"].tab
			yt13 = cs.lines["w13"].tab
			yt14 = cs.lines["w14"].tab
			yt15 = cs.lines["w15"].tab
			yt16 = cs.lines["w16"].tab
			yt17 = cs.lines["w17"].tab
			yt18 = cs.lines["w18"].tab
			yt19 = cs.lines["w19"].tab
			yt20 = cs.lines["w20"].tab
			yt21 = cs.lines["w21"].tab
			yt22 = cs.lines["w22"].tab
			yt23 = cs.lines["w23"].tab
			yt24 = cs.lines["w24"].tab
			yt25 = cs.lines["w25"].tab
			yt26 = cs.lines["w26"].tab
			yt27 = cs.lines["w27"].tab
			yt28 = cs.lines["w28"].tab
			yt29 = cs.lines["w29"].tab
			yt30 = cs.lines["w30"].tab
			yt31 = cs.lines["w31"].tab
			
			
			
			
	
	-- derived variables (from rules tables)
			h1,d1,r1,m1 = donjons.wt(w1, level, abilities, dadd)
			h2,d2,r2,m2 = donjons.wt(w2, level, abilities, dadd)
			h3,d3,r3,m3 = donjons.wt(w3, level, abilities, dadd)
			h4,d4,r4,m4 = donjons.wt(w4, level, abilities, dadd)
			h5,d5,r5,m5 = donjons.wt(w5, level, abilities, dadd)
			h6,d6,r6,m6 = donjons.wt(w6, level, abilities, dadd)
			h7,d7,r7,m7 = donjons.wt(w7, level, abilities, dadd)
			h8,d8,r8,m8 = donjons.wt(w8, level, abilities, dadd)
			h9,d9,r9,m9 = donjons.wt(w9, level, abilities, dadd)
			h10,d10,r10, m10= donjons.wt(w10, level, abilities, dadd)
			h11,d11,r11, m11= donjons.wt(w11, level, abilities, dadd)
			h12,d12,r12, m12= donjons.wt(w12, level, abilities, dadd)
			h13,d13,r13, m13= donjons.wt(w13, level, abilities, dadd)
			h14,d14,r14, m14= donjons.wt(w14, level, abilities, dadd)
			h15,d15,r15, m15= donjons.wt(w15, level, abilities, dadd)
			h16,d16,r16, m16= donjons.wt(w16, level, abilities, dadd)
			h17,d17,r17, m17= donjons.wt(w17, level, abilities, dadd)
			h18,d18,r18, m18= donjons.wt(w18, level, abilities, dadd)
			h19,d19,r19, m19= donjons.wt(w19, level, abilities, dadd)
			h20,d20,r20, m20= donjons.wt(w20, level, abilities, dadd)
			h21,d21,r21, m21= donjons.wt(w21, level, abilities, dadd)
			h22,d22,r22, m22= donjons.wt(w22, level, abilities, dadd)
			h23,d23,r23, m23= donjons.wt(w23, level, abilities, dadd)
			h24,d24,r24, m24= donjons.wt(w24, level, abilities, dadd)
			h25,d25,r25, m25= donjons.wt(w25, level, abilities, dadd)
			h26,d26,r26, m26= donjons.wt(w26, level, abilities, dadd)
			h27,d27,r27, m27= donjons.wt(w27, level, abilities, dadd)
			h28,d28,r28, m28= donjons.wt(w28, level, abilities, dadd)
			h29,d29,r29, m29= donjons.wt(w29, level, abilities, dadd)
			h30,d30,r30, m30= donjons.wt(w30, level, abilities, dadd)
			h31,d31,r31, m31= donjons.wt(w31, level, abilities, dadd)

		
			lib.ModifyLine(cs, "w1", cs.lines["w1"].mod,yt1,w1, cs.lines["w1"].extraBool, "combat tour",w1 .. "" .. " (" .. r1 .. ")", h1,d1)
			lib.ModifyLine(cs, "w2", cs.lines["w2"].mod,yt2,w2, cs.lines["w2"].extraBool, "combat tour",w2 .. "" .. " (" .. r2 .. ")", h2,d2)
			lib.ModifyLine(cs, "w3", cs.lines["w3"].mod,yt3,w3, cs.lines["w3"].extraBool, "combat tour",w3 .. "" .. " (" .. r3 .. ")", h3,d3)
			lib.ModifyLine(cs, "w4", cs.lines["w4"].mod,yt4,w4, cs.lines["w4"].extraBool, "combat tour",w4 .. "" .. " (" .. r4 .. ")", h4,d4)
			lib.ModifyLine(cs, "w5", cs.lines["w5"].mod,yt5,w5, cs.lines["w5"].extraBool, "combat tour",w5 .. "" .. " (" .. r5 .. ")", h5,d5)
			lib.ModifyLine(cs, "w6", cs.lines["w6"].mod,yt6,w6, cs.lines["w6"].extraBool, "combat tour",w6 .. "" .. " (" .. r6 .. ")", h6,d6)
			lib.ModifyLine(cs, "w7", cs.lines["w7"].mod,yt7,w7, cs.lines["w7"].extraBool, "combat tour",w7 .. "" .. " (" .. r7 .. ")", h7,d7)
			lib.ModifyLine(cs, "w8", cs.lines["w8"].mod,yt8,w8, cs.lines["w8"].extraBool, "combat tour",w8 .. "" .. " (" .. r8 .. ")", h8,d8)
			lib.ModifyLine(cs, "w9", cs.lines["w9"].mod,yt9,w9, cs.lines["w9"].extraBool, "combat tour",w9 .. "" .. " (" .. r9 .. ")", h9,d9)
			lib.ModifyLine(cs, "w10", cs.lines["w10"].mod,yt10,w10, cs.lines["w10"].extraBool, "combat sort n1",w10 .. "" .. " (" .. r10 .. ")", h10,d10)
			lib.ModifyLine(cs, "w11", cs.lines["w11"].mod,yt11,w11, cs.lines["w11"].extraBool, "combat sort n1",w11 .. "" .. " (" .. r11 .. ")", h11,d11)
			lib.ModifyLine(cs, "w12", cs.lines["w12"].mod,yt12,w12, cs.lines["w12"].extraBool, "combat sort n1",w12 .. "" .. " (" .. r12 .. ")", h12,d12)
			lib.ModifyLine(cs, "w13", cs.lines["w13"].mod,yt13,w13, cs.lines["w13"].extraBool, "combat sort n1",w13 .. "" .. " (" .. r13 .. ")", h13,d13)
			lib.ModifyLine(cs, "w14", cs.lines["w14"].mod,yt14,w14, cs.lines["w14"].extraBool, "combat sort n2",w14 .. "" .. " (" .. r14 .. ")", h14,d14)
			lib.ModifyLine(cs, "w15", cs.lines["w15"].mod,yt15,w15, cs.lines["w15"].extraBool, "combat sort n2",w15 .. "" .. " (" .. r15 .. ")", h15,d15)
			lib.ModifyLine(cs, "w16", cs.lines["w16"].mod,yt16,w16, cs.lines["w16"].extraBool, "combat sort n2",w16 .. "" .. " (" .. r16 .. ")", h16,d16)
			lib.ModifyLine(cs, "w17", cs.lines["w17"].mod,yt17,w17, cs.lines["w17"].extraBool, "combat sort n3",w17 .. "" .. " (" .. r17 .. ")", h17,d17)
			lib.ModifyLine(cs, "w18", cs.lines["w18"].mod,yt18,w18, cs.lines["w18"].extraBool, "combat sort n3",w18 .. "" .. " (" .. r18 .. ")", h18,d18)
			lib.ModifyLine(cs, "w19", cs.lines["w19"].mod,yt19,w19, cs.lines["w19"].extraBool, "combat sort n3",w19 .. "" .. " (" .. r19 .. ")", h19,d19)
			lib.ModifyLine(cs, "w20", cs.lines["w20"].mod,yt20,w20, cs.lines["w20"].extraBool, "combat sort n4",w20 .. "" .. " (" .. r20 .. ")", h20,d20)
			lib.ModifyLine(cs, "w21", cs.lines["w21"].mod,yt21,w21, cs.lines["w21"].extraBool, "combat sort n4",w21 .. "" .. " (" .. r21 .. ")", h21,d21)
			lib.ModifyLine(cs, "w22", cs.lines["w22"].mod,yt22,w22, cs.lines["w22"].extraBool, "combat sort n4",w22 .. "" .. " (" .. r22 .. ")", h22,d22)
			lib.ModifyLine(cs, "w23", cs.lines["w23"].mod,yt23,w23, cs.lines["w23"].extraBool, "combat sort n5",w23 .. "" .. " (" .. r23 .. ")", h23,d23)
			lib.ModifyLine(cs, "w24", cs.lines["w24"].mod,yt24,w24, cs.lines["w24"].extraBool, "combat sort n5",w24 .. "" .. " (" .. r24 .. ")", h24,d24)
			lib.ModifyLine(cs, "w25", cs.lines["w25"].mod,yt25,w25, cs.lines["w25"].extraBool, "combat sort n5",w25 .. "" .. " (" .. r25 .. ")", h25,d25)
			lib.ModifyLine(cs, "w26", cs.lines["w26"].mod,yt26,w26, cs.lines["w26"].extraBool, "combat sort n6",w26 .. "" .. " (" .. r26 .. ")", h26,d26)
			lib.ModifyLine(cs, "w27", cs.lines["w27"].mod,yt27,w27, cs.lines["w27"].extraBool, "combat sort n6",w27 .. "" .. " (" .. r27 .. ")", h27,d27)
			lib.ModifyLine(cs, "w28", cs.lines["w28"].mod,yt28,w28, cs.lines["w28"].extraBool, "combat sort n7",w28 .. "" .. " (" .. r28 .. ")", h28,d28)
			lib.ModifyLine(cs, "w29", cs.lines["w29"].mod,yt29,w29, cs.lines["w29"].extraBool, "combat sort n7",w29 .. "" .. " (" .. r29 .. ")", h29,d29)
			lib.ModifyLine(cs, "w30", cs.lines["w30"].mod,yt30,w30, cs.lines["w30"].extraBool, "combat sort n8",w30 .. "" .. " (" .. r30 .. ")", h30,d30)
			lib.ModifyLine(cs, "w31", cs.lines["w31"].mod,yt31,w31, cs.lines["w31"].extraBool, "combat sort n9",w31 .. "" .. " (" .. r31 .. ")", h31,d31)
	
	 return cs

end

	

-- clear dice and initialize some global variables
function donjons.DefaultClean(f2)
	-- clean
	yag.ClearDice()
	
	-- current n of analyse in the complete dice result (used to only count once each result when rerolling)
	-- nc remembers the last position of the complete dice result when adding a reroll (it is updated at the end of UpdateGrandResult)
	-- nc stands for NCurrent
	donjons.nc1 = 1
	donjons.nc2 = 1
	
	-- drd stands for Dice Results to Display
	-- briefly: drd is like a dr (Dice Result structure, see documentation) with a bit more info in its result table used to display it
	-- see the function UpdateGrandResult below for the details of the drd structure
	donjons.drd1 = {}	
	donjons.drd2 = {}	
end

-- dice roll (see documentation or yag.lua script for details)
function donjons.My_RollDiceButton(sp, cs, id, f1, f2, dro)
	-- clean and reset what's neede
	donjons.DefaultClean(f2)	
	-- don't roll if both are empty 
	if (f1~="" or f2~="") then yag.RollDice(f1, f2, dro, "First Roll") end
end
function donjons.NumberofExplosiveDice(dr, d, e)
	local n=0
	for kf,vf in pairs(dr) do
		if string.match(vf.formula, d) and vd.value >= e then n= n+1  end
	end
	r=n - donjons.np
	donjon.np= n
	return r
end

-- format and display the input Grand Result gr details
-- gr is a drd structure (Dice Result to Display, see UpdateGrandResult for details) and is simply the complete result of the current roll (initial roll + all the rerolls)
function donjons.DiceResultDetail(gr)
	local s = ""
	for kf,vf in pairs(gr) do	
		-- keep only the initial of the color (black=bl, white=wh, wood=wo)
		s = s .. string.format("%s%s:\n", vf.formula, vf.color=="" and "" or " (" .. vf.color .. ")")
		local sign = donjons.GetSign(vf.formula)
		
		for kd,vd in pairs(vf.result) do
			s = s .. string.format("<%s>%s%s</>%s, ", vd.keep and "black" or "gray", sign=="+" and "" or sign, vd.label, vd.explode and "<red>*</>" or " ")
			
			--Ajout Zul Critique (A refaire)
			
			
			if (vd.value == 20) and ((vf.formula == "+1d20") or (vf.formula == "+2d20h1") or (vf.formula == "+2d20l1")) then
				s = s.. "<blue>CRITIQUE !</>  "
			end
			if (vd.value == 1) and ((vf.formula == "+1d20") or (vf.formula == "+2d20h1") or (vf.formula == "+2d20l1")) then
				s = s.. "<cyan>FUMBLE !</>  "
			end
			
			
		end
		-- replace the last ", " by a newline
		s = string.sub(s, 0, string.len(s) - 2) .. "\n"
		
	end
	return s
end

-- returns a string containing the sign of input formula f
function donjons.GetSign(f)
	-- formula sign
	local s = string.match(f, "[(^%+)(^%-)]")
	if s==nil then s = "+" end
	return s
	
end

-- format and display the input Grand Result gr total
-- gr is a drd structure (Dice Result to Display, see UpdateGrandResult for details) and is simply the complete result of the current roll (initial roll + all the rerolls)
function donjons.DiceResultTotal(gr)
	local s = 0
	for kf,vf in pairs(gr) do
		-- sign=="-" ? -1 : 1
		pm1 = donjons.GetSign(vf.formula)=="-" and -1 or 1
		-- total
		for kd,vd in pairs(vf.result) do
			if vd.keep then s = s + pm1 * vd.value end
		end
	end
	return s
end

-- returns a table of the highest or lowest (depending on hl = "h" or "l") results to keep from input Result r.
-- Result r is the following table: { (int)value, (string)label, (string)color, (bool)keep, (bool)explode }
-- here, we sort r by value and return the ni highest or lowest
function donjons.GetResultsToKeep(r, hl, ni)
	-- limit n to #r
	local n = math.min(ni,#r)

	-- create a table that we can sort while keeping the key
	local ts = {}
	for k,v in pairs(r) do
		ts[k] = { key = k, value = v.value }
	end

	-- sort the table by value
	table.sort(ts, function(a, b) return a.value<b.value end)

	-- keep the n highest/lowest in tn
	local d -- offset (d=delta)

	if (hl=="h") then
		-- highest: start at #ts-n
		d = #ts-n
	elseif (hl=="l") then
		--lowest: start at 1
		d = 0
	else
		-- nil: take everything
		hl="h"
		n=#ts
		d=0
	end

	local tn = {}
	for i=1,n do tn[i] = ts[i+d] end

	-- create the table with only the keys of the two highest
	local tr = {}
	for k,v in pairs(tn) do tr[k] = v.key end
	return tr
end

-- returns "h" or "l" from the formula
function donjons.GetHlFromFormula(f)
	local hl = string.match(f, "[hl]")
	-- hl==nil ? "" : hl
	return hl==nil and "" or hl
end

-- update the input Dice Result to Display drd using the input Dice Result dr
-- a drd is a bit like a Dice Result dr (see documentation for details) except its result table contains more fields used to display it.
-- for die i, drd is created/updated in those lines which give it complete structure:
-- drd[i] = { formula = dr[i].formula, color = dr[i].color, result = {} }
-- drd[i].result[kd] = { value = vd.value, label = vd.label, color = vd.color, keep = false, explode = enb }
function donjons.UpdateGrandResult(dr, drd)	
	-- reroll formula
	local rrf = ""
	
	-- if drd1 take nc1, otherwise take nc2 (equivalent to a ? b : c)
	local nc = drd==donjons.drd1 and donjons.nc1 or donjons.nc2
	
	-- from last index position to the end
	for i=nc,#dr do
		drd[i] = { formula = dr[i].formula, color = dr[i].color, result = {} }
		
		-- extract h, l and n
		local f = dr[i].formula:lower()
		
		-- dice type
		local type = string.match(f, "d(%d+)")
		if type==nil then type = "0" end
		
		-- keep highest or lowest
		local hln = #dr
		local hlnt = nil
		local hl = donjons.GetHlFromFormula(f)
		if hl~="" then hlnt = string.match(f, hl.."(%d+)") end
		if hlnt~=nil then hln = tonumber(hlnt) end
		
		-- explode number
		local en = 0
		local ent = string.match(f, "e(%d+)")
		if ent~=nil then en = tonumber(ent) end
		
		-- fill results for current formula and mark exploding dice
		for kd,vd in pairs(dr[i].result) do
			local enb = false
			if en > 0 then enb = vd.value >= tonumber(ent) end
			drd[i].result[kd] = { value = vd.value, label = vd.label, color = vd.color, keep = false, explode = enb }			
		end
		
		-- number of dice to reroll
		local nr = 0
		
		-- mark dice to keep
		local tr = donjons.GetResultsToKeep(drd[i].result, hl, hln)
		for ktr, vtr in pairs(tr) do
			drd[i].result[vtr].keep = true
		
			-- reroll die if keep and explode
			if (drd[i].result[vtr].keep and drd[i].result[vtr].explode) then nr = nr + 1 end
		end
		if nr > 0 then
			rrf = rrf .. "+" .. nr .. "d" .. type .. "e" .. en
		end
	end
	
	-- remember the current position of the result in the drd to only count what's behind it when rerolling
	if (drd==donjons.drd1) then donjons.nc1 = #dr + 1 else donjons.nc2 = #dr + 1 end
	return rrf
end

-- dice roll Callback (see documentation or yag.lua script for details)
-- sp: table of selected pawns ids
-- cs: table containing the character sheet info (if any: can be nil)
-- id: id of the line in the selected character sheet (if any, can be nil)
-- dr1, dr2: tables containing the dice results for formula 1 and 2
-- pd: boolean reporting whether or nor the dice roll was requested to be private by the user in Yag
-- ui: integer offered to the player, here it is used to propagate the dice roll origin (dro)
-- us: string offered to the player, here used to specify first roll and rerolls as an example

function donjons.My_RollDiceCallback(sp, cs, id, dr1, dr2, pd, ui, us)
	--yag.PublicMessage(us)
	--if (ui==1) then yag.PublicMessage("rolling from cs line") end
	--if (ui==2) then yag.PublicMessage("rolling from dice panel") end
	--if (ui==3) then yag.PublicMessage("rolling an initiative") end
	
	-- update the complete results that will be used at the end for displaying the details and computing the grand total
	-- rr stands for reroll
	rr1 = donjons.UpdateGrandResult(dr1, donjons.drd1)
	rr2 = donjons.UpdateGrandResult(dr2, donjons.drd2)
	
	--modification des PV max au changement de niveau ok
	if (id == "O12") then 
			Hpperlevel = donjons.DiceResultTotal(donjons.drd2)
			Hpmax = tonumber(cs.lines["L1"].formula1)
			if (tonumber(cs.lines["lvl"].formula1) >= 2) then
				cs.maxhp = Hpperlevel + Hpmax
				cs.lines["L1"].formula1 = tostring(cs.maxhp)
			yag.UpdateCS(cs)
			yag.UpdatePawn({id}, psid)
			end
	else if (id == "Z34") then cs.maxhp = donjons.DiceResultTotal(donjons.drd1)
				yag.UpdateCS(cs)
			--yag.UpdatePawn(psid)
	end
	end
	
	-- count dice to reroll à modifier
	--local n = donjons.NumberofExplosiveDice(dr1, "d20", 20)
	--Yag.LocalMessage(string.format("n reroll: %d",n))
	
	--if n > 0 then yag.RollDice("", n .. "%d") end
	-- if none display the result
	--if (n == 0) then donjons.DisplayDiceResults(cs, id, dr1, dr2) end

	-- reroll if one of the reroll strings is not empty
	if (rr1~="" or rr2~="") then
		yag.RollDice(rr1,rr2, ui, "Rerolling !")
	-- else do what must be done with the results
	else 
		-- update the initiative for the selected pawns   ok
		if (ui==3) then
			--valeur = donjons.abilityMod(tonumber(cs.lines["Z2"].extraString))
			--cs.lines["Z2"].formula1 = tostring(valeur)
			for k, id in pairs(sp) do
				--yag.PublicMessage("Updating id: " .. id)
				psid, csid = yag.GetPawnInfo(id)
				-- new init = total of the dice
				psid.initiative = donjons.DiceResultTotal(donjons.drd1) 
				yag.UpdatePawn({id}, psid)
				--yag.PublicMessage(string.format("New state of %s: %d (health), %d (init) %s (round)", v, psid.health, psid.initiative, tostring(psid.round)))
			end
		end
		
		--potion de soin 
			if (id == "G5") then
				potionNumber = tonumber(cs.lines["G5"].formula1)
				potioneffect = tonumber(donjons.DiceResultTotal(donjons.drd2))
				cs.lines["G5"].formula1 = tostring(potionNumber -1)
				-- si total > PV max, alors PV courant = PV max
				if (tonumber(cs.lines["L3"].formula1) + potioneffect) > tonumber(cs.lines["L1"].formula1) then
					cs.lines["L3"].formula1 = cs.lines["L1"].formula1
				else
					cs.lines["L3"].formula1 = tostring(tonumber(cs.lines["L3"].formula1) + potioneffect)
				end
				for k, id in pairs(sp) do
					psid, csid = yag.GetPawnInfo(id)
					hp = tonumber(cs.lines["L3"].formula1)
					psid.health = hp
					yag.UpdatePawn({id}, psid)	
				end	
				yag.UpdateCS(cs)
				yag.PublicMessage(rs)
			end
		
		--Potion de soin 2
			if (id == "G6") then
				potionNumber = tonumber(cs.lines["G6"].formula1)
				potioneffect = tonumber(donjons.DiceResultTotal(donjons.drd2))
				cs.lines["G6"].formula1 = tostring(potionNumber -1)
				-- si total > PV max, alors PV courant = PV max
				if (tonumber(cs.lines["L3"].formula1) + potioneffect) > tonumber(cs.lines["L1"].formula1) then
					cs.lines["L3"].formula1 = cs.lines["L1"].formula1
				else
					cs.lines["L3"].formula1 = tostring(tonumber(cs.lines["L3"].formula1) + potioneffect)
				end
				for k, id in pairs(sp) do
					psid, csid = yag.GetPawnInfo(id)
					hp = tonumber(cs.lines["L3"].formula1)
					psid.health = hp
					yag.UpdatePawn({id}, psid)	
				end	
				yag.UpdateCS(cs)
				yag.PublicMessage(rs)
			end

	end				
		
		-- display the details/total result string                        avec modifications si l extrabool de la rage en Z11 est activé ou non
		if (id == "Z11")	then 
			local detail1 = donjons.DiceResultDetail(donjons.drd1)
			local detail2 = donjons.DiceResultDetail(donjons.drd2)
			local detail3 = donjons.DiceResultDetail(donjons.drd1) .. "+" .. tonumber(cs.lines["Z11"].formula1) .. "  (rage)"
			local detail4 = donjons.DiceResultDetail(donjons.drd2) .. "+" .. tonumber(cs.lines["Z11"].formula1) .. "  (rage)"
			local rs = string.format("--TOUR DE--<red>%s</>:\n", cs.name)
			
			if (detail1~="") then
				if (ui==1) then rs = rs .. string.format("<red>%s (jet d´attaque)</>:\n", cs.lines[id].string2) end
				if (ui==3) then rs = rs .. string.format("<red>Initiative</>:\n") end
			
				if (cs.lines["Z11"].extraBool == true) then 
					rs = rs .. detail3
					rs = rs .. string.format("\n Total: <red>%d</>\n", donjons.DiceResultTotal(donjons.drd1) + tonumber(cs.lines["Z11"].formula1))
				else detail1 = donjons.DiceResultDetail(donjons.drd1) 
				rs = rs .. detail1
				rs = rs .. string.format("Total: <red>%d</>\n", donjons.DiceResultTotal(donjons.drd1))
				end
			end
		
			if (detail2~="") then
				if (detail1~="") then rs = rs .. "\n" end
				if (ui==1) then rs = rs .. string.format("<red>%s (dégâts)</>:\n", cs.lines[id].string2) end
					if (cs.lines["Z11"].extraBool == true) then 
							rs = rs .. detail4
							rs = rs .. string.format("\n Total: <red>%d</>\n", donjons.DiceResultTotal(donjons.drd2) + tonumber(cs.lines["Z11"].formula1))
					else rs = rs .. detail2
					rs = rs .. string.format("Total: <red>%d</>\n", donjons.DiceResultTotal(donjons.drd2))
					end
			end
			-- trigger attack animation for selected pawns
			if (next(sp)~=nil) then yag.PawnAttack(sp) end
		
	
		else 
			local detail1 = donjons.DiceResultDetail(donjons.drd1)
			local detail2 = donjons.DiceResultDetail(donjons.drd2)
			local rs = string.format("--TOUR DE--<red>%s</>:\n", cs.name)
			if (detail1~="") then
				if (ui==1) then rs = rs .. string.format("<red>%s (jet d´attaque)</>:\n", cs.lines[id].string2) end
				if (ui==3) then rs = rs .. string.format("<red>Initiative</>:\n") end
				rs = rs .. detail1
				rs = rs .. string.format("Total: <red>%d</>\n", donjons.DiceResultTotal(donjons.drd1))
			end
			if (detail2~="") then
				if (detail1~="") then rs = rs .. "\n" end
				if (ui==1) then rs = rs .. string.format("<red>%s (dégâts)</>:\n", cs.lines[id].string2) end
				rs = rs .. detail2
				rs = rs .. string.format("Total: <red>%d</>\n", donjons.DiceResultTotal(donjons.drd2))
			end	
		if (pd) then
		yag.LocalMessage(rs)
		else
		yag.PublicMessage(rs)
		end	
			
			-- trigger attack animation for selected pawns
		if (next(sp)~=nil) then yag.PawnAttack(sp) end
	
		end
	
	
end	

return donjons
		
	
		

		
		
